## xrootd 5.8.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.31 FATAL_ERROR)

# Check for in-source builds
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "XRootD cannot be built in-source! "
                      "Please run cmake <src-dir> outside the "
                      "source directory and be sure to remove "
                      "CMakeCache.txt or CMakeFiles if they "
                      "exist in the source directory.")
endif()

project( XRootD )

set( CMAKE_MODULE_PATH
 ${PROJECT_SOURCE_DIR}/src
 ${PROJECT_SOURCE_DIR}/cmake )

# Place build artifacts in ${CMAKE_BINARY_DIR}/{bin,lib}
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin CACHE PATH "")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib CACHE PATH "")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib CACHE PATH "")

include(XRootDVersion)

#-------------------------------------------------------------------------------
# A 'plugins' phony target to simplify building build-tree binaries.
# Plugins are responsible for adding themselves to this target, where
# appropriate.
#-------------------------------------------------------------------------------
ADD_CUSTOM_TARGET(plugins)

include(GNUInstallDirs)

include( XRootDOSDefs )
include( XRootDDefaults )
include( XRootDSystemCheck )
include( XRootDFindLibs )

#-------------------------------------------------------------------------------
# Generate the version header
#-------------------------------------------------------------------------------

configure_file(src/XrdVersion.hh.in src/XrdVersion.hh)

#-------------------------------------------------------------------------------
# Build in subdirectories
#-------------------------------------------------------------------------------

include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR}/src)

include(CTest)

add_subdirectory(src)
add_subdirectory(bindings)
add_subdirectory(tests)

add_subdirectory(docs)
add_subdirectory(utils)

include( XRootDSummary )


#-------------------------------------------------------------------------------
# Install XRootDConfig.cmake module
#-------------------------------------------------------------------------------

include(CMakePackageConfigHelpers)

write_basic_package_version_file(cmake/${PROJECT_NAME}ConfigVersion.cmake
  VERSION ${XRootD_VERSION} COMPATIBILITY SameMajorVersion)

configure_package_config_file(cmake/${PROJECT_NAME}Config.cmake.in cmake/${PROJECT_NAME}Config.cmake
  INSTALL_PREFIX
    ${CMAKE_INSTALL_PREFIX}
  INSTALL_DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  PATH_VARS
    CMAKE_INSTALL_BINDIR
    CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_LIBDIR
    CMAKE_INSTALL_DATADIR
)

install(DIRECTORY ${PROJECT_BINARY_DIR}/cmake/
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

#-------------------------------------------------------------------------------
# Configure an 'uninstall' target
#-------------------------------------------------------------------------------
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# If this is a build for pip set up the rpath
# (this is especially important for plugins)
#-------------------------------------------------------------------------------
if( PYPI_BUILD )
  set( CMAKE_INSTALL_RPATH "$ORIGIN" )
  set( CMAKE_INSTALL_RPATH_USE_LINK_PATH true )
endif()

#-------------------------------------------------------------------------------
# XRDCL_LIB_ONLY implies XRDCL_ONLY
#-------------------------------------------------------------------------------
if( XRDCL_LIB_ONLY )
  set ( XRDCL_ONLY TRUE )
endif()

include( XrdHeaders )

add_library(XrdUtils SHARED)

set_target_properties(XrdUtils
  PROPERTIES BUILD_RPATH $ORIGIN VERSION 3.0.0 SOVERSION 3
)

target_link_libraries(XrdUtils
  PRIVATE
    OpenSSL::SSL
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
    ${SOCKET_LIBRARY}
    ${SENDFILE_LIBRARY}
    ${EXTRA_LIBS}
)

if(SYSTEMD_FOUND)
  target_link_libraries(XrdUtils PRIVATE ${SYSTEMD_LIBRARIES})
endif()

install(TARGETS XrdUtils LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_subdirectory( XProtocol )
add_subdirectory( Xrd )
add_subdirectory( XrdCks )
add_subdirectory( XrdNet )
add_subdirectory( XrdSut )
add_subdirectory( XrdSys )
add_subdirectory( XrdOuc )
add_subdirectory( XrdTls )
add_subdirectory( XrdRmc )

add_subdirectory( XrdApps )
add_subdirectory( XrdCrypto )
add_subdirectory( XrdPosix )

add_subdirectory( XrdSec )
add_subdirectory( XrdSecgsi )
add_subdirectory( XrdSeckrb5 )
add_subdirectory( XrdSecpwd )
add_subdirectory( XrdSecsss )
add_subdirectory( XrdSecunix )
add_subdirectory( XrdSecztn )

add_subdirectory( XrdXml )

add_subdirectory( XrdCl )
add_subdirectory( XrdClHttp )
add_subdirectory( XrdEc )

if( NOT XRDCL_ONLY )
  add_library(XrdServer SHARED)

  set_target_properties(XrdServer
    PROPERTIES VERSION 3.0.0 SOVERSION 3
  )

  target_link_libraries(XrdServer
    PRIVATE
    XrdUtils
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${ATOMIC_LIBRARY}
    ${EXTRA_LIBS}
    ${SOCKET_LIBRARY}
  )

  install(TARGETS XrdServer LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

  add_subdirectory( XrdAcc )
  add_subdirectory( XrdCms )
  add_subdirectory( XrdDig )
  add_subdirectory( XrdFrc )
  add_subdirectory( XrdOfs )
  add_subdirectory( XrdOss )
  add_subdirectory( XrdSfs )
  add_subdirectory( XrdXrootd )

  add_subdirectory( XrdFrm )
  add_subdirectory( XrdFfs )
  add_subdirectory( XrdBwm )
  add_subdirectory( XrdPss )
  add_subdirectory( XrdSsi )
  add_subdirectory( XrdPfc )
  add_subdirectory( XrdOssCsi )
  add_subdirectory( XrdOssStats )
  add_subdirectory( XrdThrottle )

  add_subdirectory( XrdHttp )
  add_subdirectory( XrdHttpTpc )

  add_subdirectory( XrdMacaroons )
  add_subdirectory( XrdVoms )
  add_subdirectory( XrdCeph )
  add_subdirectory( XrdSciTokens )
endif()

=== tests/CMakeLists.txt ===
if(NOT BUILD_TESTS)
  return()
endif()

include(GoogleTest)

add_subdirectory(common)

add_subdirectory(XrdCl)
add_subdirectory(XrdCeph)
add_subdirectory(XrdEc)
add_subdirectory(XrdPosix)

add_subdirectory(XrdHttpTests)

add_subdirectory(XrdOucTests)

add_subdirectory( XrdSsiTests )

add_subdirectory(XrdHttpTpc)

add_subdirectory(XrdPfcTests)

if( BUILD_SCITOKENS )
  add_subdirectory( scitokens )
endif()

if(NOT ENABLE_SERVER_TESTS)
  return()
endif()

add_subdirectory( XrdOssTests )
add_subdirectory( XRootD )
add_subdirectory( cluster )
add_subdirectory( stress )
add_subdirectory( TPCTests )
add_subdirectory( badredir )

=== src/XrdBwm/CMakeLists.txt ===
set(XrdBwm XrdBwm-${PLUGIN_VERSION})

add_library(${XrdBwm} MODULE
  XrdBwm.cc         XrdBwm.hh
  XrdBwmConfig.cc
  XrdBwmHandle.cc   XrdBwmHandle.hh
  XrdBwmLogger.cc   XrdBwmLogger.hh
  XrdBwmPolicy1.cc  XrdBwmPolicy1.hh
                    XrdBwmPolicy.hh
                    XrdBwmTrace.hh
)

target_link_libraries(${XrdBwm}
  PRIVATE
    XrdServer
    XrdUtils
    ${CMAKE_THREAD_LIBS_INIT}
)

install(TARGETS ${XrdBwm} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdCks/CMakeLists.txt ===
target_sources(XrdUtils
  PRIVATE
    XrdCksAssist.cc      XrdCksAssist.hh
    XrdCksCalccrc32.cc   XrdCksCalccrc32.hh
    XrdCksCalccrc32C.cc  XrdCksCalccrc32C.hh
    XrdCksCalcmd5.cc     XrdCksCalcmd5.hh
    XrdCksConfig.cc      XrdCksConfig.hh
    XrdCksLoader.cc      XrdCksLoader.hh
    XrdCksManager.cc     XrdCksManager.hh
    XrdCksManOss.cc      XrdCksManOss.hh
                         XrdCksCalcadler32.hh
                         XrdCksCalc.hh
                         XrdCksData.hh
                         XrdCks.hh
                         XrdCksXAttr.hh
)

#-------------------------------------------------------------------------------
# libz compatible CRC32 plugin
#-------------------------------------------------------------------------------
set(XrdClsCalczcrc32 XrdCksCalczcrc32-${PLUGIN_VERSION})

add_library(${XrdClsCalczcrc32} MODULE XrdCksCalczcrc32.cc)
target_link_libraries(${XrdClsCalczcrc32} PRIVATE XrdUtils ZLIB::ZLIB)

install(TARGETS ${XrdClsCalczcrc32} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdCl/CMakeLists.txt ===
if(NOT ENABLE_XRDCL)
  return()
endif()

add_library(XrdCl SHARED
  XrdClLog.cc                    XrdClLog.hh
  XrdClUtils.cc                  XrdClUtils.hh
                                 XrdClOptimizers.hh
                                 XrdClConstants.hh
  XrdClEnv.cc                    XrdClEnv.hh
  XrdClDefaultEnv.cc             XrdClDefaultEnv.hh
  XrdClURL.cc                    XrdClURL.hh
  XrdClStatus.cc                 XrdClStatus.hh
  XrdClSocket.cc                 XrdClSocket.hh
  XrdClTls.cc                    XrdClTls.hh
                                 XrdClPoller.hh
  XrdClPollerFactory.cc          XrdClPollerFactory.hh
  XrdClPollerBuiltIn.cc          XrdClPollerBuiltIn.hh
  XrdClPostMaster.cc             XrdClPostMaster.hh
                                 XrdClPostMasterInterfaces.hh
  XrdClChannel.cc                XrdClChannel.hh
  XrdClStream.cc                 XrdClStream.hh
  XrdClXRootDTransport.cc        XrdClXRootDTransport.hh
  XrdClInQueue.cc                XrdClInQueue.hh
  XrdClOutQueue.cc               XrdClOutQueue.hh
  XrdClTaskManager.cc            XrdClTaskManager.hh
  XrdClSIDManager.cc             XrdClSIDManager.hh
  XrdClFileSystem.cc             XrdClFileSystem.hh
  XrdClXRootDMsgHandler.cc       XrdClXRootDMsgHandler.hh
                                 XrdClBuffer.hh
                                 XrdClMessage.hh
  XrdClMessageUtils.cc           XrdClMessageUtils.hh
  XrdClXRootDResponses.cc        XrdClXRootDResponses.hh
                                 XrdClRequestSync.hh
  XrdClFile.cc                   XrdClFile.hh
  XrdClFileStateHandler.cc       XrdClFileStateHandler.hh
  XrdClCopyProcess.cc            XrdClCopyProcess.hh
  XrdClClassicCopyJob.cc         XrdClClassicCopyJob.hh
  XrdClThirdPartyCopyJob.cc      XrdClThirdPartyCopyJob.hh
  XrdClAsyncSocketHandler.cc     XrdClAsyncSocketHandler.hh
  XrdClChannelHandlerList.cc     XrdClChannelHandlerList.hh
  XrdClForkHandler.cc            XrdClForkHandler.hh
  XrdClCheckSumManager.cc        XrdClCheckSumManager.hh
  XrdClTransportManager.cc       XrdClTransportManager.hh
                                 XrdClSyncQueue.hh
  XrdClJobManager.cc             XrdClJobManager.hh
                                 XrdClResponseJob.hh
  XrdClFileTimer.cc              XrdClFileTimer.hh
                                 XrdClPlugInInterface.hh
  XrdClPlugInManager.cc          XrdClPlugInManager.hh
                                 XrdClPropertyList.hh
                                 XrdClCopyJob.hh
  XrdClFileSystemUtils.cc        XrdClFileSystemUtils.hh
  XrdClTPFallBackCopyJob.cc      XrdClTPFallBackCopyJob.hh
  XrdClMetalinkRedirector.cc     XrdClMetalinkRedirector.hh
  XrdClRedirectorRegistry.cc     XrdClRedirectorRegistry.hh
  XrdClXCpCtx.cc                 XrdClXCpCtx.hh
  XrdClXCpSrc.cc                 XrdClXCpSrc.hh
  XrdClLocalFileHandler.cc       XrdClLocalFileHandler.hh
  XrdClLocalFileTask.cc          XrdClLocalFileTask.hh
  XrdClZipListHandler.cc         XrdClZipListHandler.hh
  XrdClZipArchive.cc             XrdClZipArchive.hh
  XrdClOperations.cc             XrdClOperations.hh
  XrdClOperationHandlers.hh
  XrdClArg.hh
  XrdClFwd.hh
  XrdClParallelOperation.hh
  XrdClFileOperations.hh
  XrdClFileSystemOperations.hh
  XrdClZipOperations.hh
)

target_link_libraries(XrdCl
  PRIVATE
    XrdXml
    XrdUtils
    uuid::uuid
    ZLIB::ZLIB
    OpenSSL::SSL
    ${CMAKE_THREAD_LIBS_INIT}
    ${EXTRA_LIBS}
    ${CMAKE_DL_LIBS}
)

if(BUILD_XRDEC)
  target_sources(XrdCl
    PRIVATE
      ../XrdEc/XrdEcRedundancyProvider.cc
      ../XrdEc/XrdEcUtilities.cc
      ../XrdEc/XrdEcStrmWriter.cc
      ../XrdEc/XrdEcReader.cc
      XrdClEcHandler.cc
  )

  target_compile_definitions(XrdCl PRIVATE WITH_XRDEC)
  target_include_directories(XrdCl PRIVATE ${ISAL_INCLUDE_DIRS})
  target_link_libraries(XrdCl PRIVATE ${ISAL_LIBRARIES})
endif()

set_target_properties(XrdCl
  PROPERTIES VERSION 3.0.0 SOVERSION 3)

install(
  FILES
    XrdClAnyObject.hh
    XrdClBuffer.hh
    XrdClConstants.hh
    XrdClCopyProcess.hh
    XrdClDefaultEnv.hh
    XrdClEnv.hh
    XrdClFile.hh
    XrdClFileSystem.hh
    XrdClFileSystemUtils.hh
    XrdClMonitor.hh
    XrdClStatus.hh
    XrdClURL.hh
    XrdClXRootDResponses.hh
    XrdClOptional.hh
    XrdClPlugInInterface.hh
    XrdClPropertyList.hh
    XrdClLog.hh
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/XrdCl
)

install(
  FILES
    # Additional client headers
    XrdClJobManager.hh
    XrdClMessage.hh
    XrdClPlugInManager.hh
    XrdClPostMaster.hh
    XrdClPostMasterInterfaces.hh
    XrdClTransportManager.hh
    XrdClResponseJob.hh
    XrdClSyncQueue.hh
    XrdClZipArchive.hh
    XrdClZipCache.hh
    # Declarative operations
    XrdClOperations.hh
    XrdClOperationHandlers.hh
    XrdClOperationTimeout.hh
    XrdClArg.hh
    XrdClCtx.hh
    XrdClFwd.hh
    XrdClParallelOperation.hh
    XrdClFileOperations.hh
    XrdClFileSystemOperations.hh
    XrdClFinalOperation.hh
    XrdClUtils.hh
    XrdClXRootDTransport.hh
    XrdClZipOperations.hh
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/private/XrdCl
)

install(
  TARGETS
    XrdCl
  LIBRARY
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PRIVATE_HEADER
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/private/XrdCl
)

if(NOT XRDCL_LIB_ONLY)
  add_executable(xrdcp XrdClCopy.cc)

  target_link_libraries(xrdcp
    XrdCl
    XrdUtils
    XrdAppUtils
  )

  add_executable(xrdfs XrdClFS.cc XrdClFSExecutor.cc XrdClFSExecutor.hh)

  target_link_libraries(xrdfs
    XrdCl
    XrdUtils
    ${READLINE_LIBRARY}
    ${NCURSES_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
  )

  if(READLINE_FOUND)
    target_include_directories(xrdfs PRIVATE ${READLINE_INCLUDE_DIR})
  endif()

  install(
    TARGETS
      xrdcp
      xrdfs
    RUNTIME
      DESTINATION ${CMAKE_INSTALL_BINDIR}
  )

  install(CODE "
    execute_process(COMMAND ln -sf xrdcp xrdcopy
      WORKING_DIRECTORY \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}
    )
  ")
endif()

=== src/XrdClHttp/CMakeLists.txt ===
if(NOT BUILD_XRDCLHTTP)
  return()
endif()

set(XrdClHttp "XrdClHttp-${PLUGIN_VERSION}")

add_library(${XrdClHttp} MODULE
  XrdClHttpFilePlugIn.cc
  XrdClHttpFileSystemPlugIn.cc
  XrdClHttpPlugInFactory.cc
  XrdClHttpPlugInUtil.cc
  XrdClHttpPosix.cc
)

target_link_libraries(${XrdClHttp} PRIVATE XrdCl XrdUtils Davix::Davix)

install(TARGETS ${XrdClHttp} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdCrypto/CMakeLists.txt ===

# This is to avoid linking XrdUtils against all of libXrdCryptossl

target_sources(XrdUtils PRIVATE
  XrdCryptoAux.cc         XrdCryptoAux.hh
  XrdCryptoRSA.cc         XrdCryptoRSA.hh
                          XrdCryptoTrace.hh
  XrdCryptoX509.cc        XrdCryptoX509.hh
  XrdCryptoX509Chain.cc   XrdCryptoX509Chain.hh
  XrdCryptoX509Crl.cc     XrdCryptoX509Crl.hh
  XrdCryptoX509Req.cc     XrdCryptoX509Req.hh
  XrdCryptosslAux.cc      XrdCryptosslAux.hh
  XrdCryptosslRSA.cc      XrdCryptosslRSA.hh
  XrdCryptosslX509.cc     XrdCryptosslX509.hh
  XrdCryptosslX509Crl.cc  XrdCryptosslX509Crl.hh
  XrdCryptosslX509Req.cc  XrdCryptosslX509Req.hh
  XrdCryptosslgsiAux.cc
)

add_library(XrdCryptoLite SHARED
  XrdCryptoLite.cc  XrdCryptoLite.hh
  XrdCryptoLite_bf32.cc
)

target_link_libraries(XrdCryptoLite PRIVATE XrdUtils OpenSSL::Crypto)
set_target_properties(XrdCryptoLite PROPERTIES VERSION 2.0.0 SOVERSION 2)

add_library(XrdCrypto SHARED
  XrdCryptoAux.cc           XrdCryptoAux.hh
  XrdCryptoBasic.cc         XrdCryptoBasic.hh
  XrdCryptoCipher.cc        XrdCryptoCipher.hh
  XrdCryptoFactory.cc       XrdCryptoFactory.hh
  XrdCryptoMsgDigest.cc     XrdCryptoMsgDigest.hh
  XrdCryptoRSA.cc           XrdCryptoRSA.hh
                            XrdCryptoTrace.hh
  XrdCryptoX509.cc          XrdCryptoX509.hh
  XrdCryptoX509Chain.cc     XrdCryptoX509Chain.hh
  XrdCryptoX509Crl.cc       XrdCryptoX509Crl.hh
  XrdCryptoX509Req.cc       XrdCryptoX509Req.hh
  XrdCryptogsiX509Chain.cc  XrdCryptogsiX509Chain.hh
)

target_link_libraries(XrdCrypto PRIVATE XrdUtils ${CMAKE_DL_LIBS})
set_target_properties(XrdCrypto PROPERTIES VERSION 2.0.0 SOVERSION 2)

set(XrdCryptossl XrdCryptossl-${PLUGIN_VERSION})

add_library(${XrdCryptossl} MODULE
  XrdCryptosslAux.cc       XrdCryptosslAux.hh
  XrdCryptosslCipher.cc    XrdCryptosslCipher.hh
  XrdCryptosslFactory.cc   XrdCryptosslFactory.hh
  XrdCryptosslMsgDigest.cc XrdCryptosslMsgDigest.hh
  XrdCryptosslRSA.cc       XrdCryptosslRSA.hh
                           XrdCryptosslTrace.hh
  XrdCryptosslX509.cc      XrdCryptosslX509.hh
  XrdCryptosslX509Crl.cc   XrdCryptosslX509Crl.hh
  XrdCryptosslX509Req.cc   XrdCryptosslX509Req.hh
  XrdCryptosslgsiAux.cc
)

target_link_libraries(${XrdCryptossl}
  PRIVATE
    XrdCrypto
    XrdUtils
    OpenSSL::SSL
    ${CMAKE_THREAD_LIBS_INIT}
)

add_dependencies(plugins ${XrdCryptossl})

install(
  TARGETS
    XrdCrypto
    XrdCryptoLite
    ${XrdCryptossl}
  LIBRARY
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/XrdHttp/CMakeLists.txt ===
if(NOT BUILD_HTTP)
  return()
endif()

# Note that XrdHttpUtils is marked as a shared library as XrdHttp plugins
# are expected to link against it for the XrdHttpExt class implementations.

add_library(XrdHttpUtils SHARED
  XrdHttpChecksum.cc         XrdHttpChecksum.hh
  XrdHttpChecksumHandler.cc  XrdHttpChecksumHandler.hh
  XrdHttpExtHandler.cc       XrdHttpExtHandler.hh
  XrdHttpProtocol.cc         XrdHttpProtocol.hh
  XrdHttpReadRangeHandler.cc XrdHttpReadRangeHandler.hh
  XrdHttpReq.cc              XrdHttpReq.hh
                             XrdHttpSecXtractor.hh
  XrdHttpSecurity.cc
                             XrdHttpStatic.hh
                             XrdHttpTrace.hh
  XrdHttpUtils.cc            XrdHttpUtils.hh
)

set_target_properties(XrdHttpUtils
  PROPERTIES VERSION 2.0.0 SOVERSION 2)

target_link_libraries(XrdHttpUtils
  PRIVATE
    XrdServer
    XrdUtils
    XrdCrypto
  PUBLIC
    OpenSSL::SSL
    OpenSSL::Crypto
)

set(XrdHttp XrdHttp-${PLUGIN_VERSION})
add_library(${XrdHttp} MODULE XrdHttpModule.cc)
target_link_libraries(${XrdHttp} PRIVATE XrdUtils XrdHttpUtils)
set_target_properties(${XrdHttp} PROPERTIES SUFFIX ".so")

install(
  TARGETS
    ${XrdHttp}
    XrdHttpUtils
  LIBRARY
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/XrdHttpTpc/CMakeLists.txt ===
unset(BUILD_TPC CACHE)

if(NOT ENABLE_HTTP)
  return()
endif()

if(FORCE_ENABLED)
  find_package(CURL 7.9.6 REQUIRED)
else()
  find_package(CURL 7.9.6)
endif()

if(CURL_FOUND)
  set(BUILD_TPC TRUE CACHE INTERNAL "")
else()
  return()
endif()

set(XrdHttpTPC XrdHttpTPC-${PLUGIN_VERSION})

add_library(${XrdHttpTPC} MODULE
  XrdHttpTpcConfigure.cc
  XrdHttpTpcMultistream.cc
  XrdHttpTpcPMarkManager.cc  XrdHttpTpcPMarkManager.hh
  XrdHttpTpcState.cc         XrdHttpTpcState.hh
  XrdHttpTpcStream.cc        XrdHttpTpcStream.hh
  XrdHttpTpcTPC.cc           XrdHttpTpcTPC.hh
  XrdHttpTpcUtils.cc         XrdHttpTpcUtils.hh
)

target_link_libraries(${XrdHttpTPC}
  PRIVATE
    XrdServer
    XrdUtils
    XrdHttpUtils
    CURL::libcurl
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
)

if(NOT APPLE)
  target_link_options(${XrdHttpTPC} PRIVATE
    "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export-lib-symbols")
endif()

install(TARGETS ${XrdHttpTPC} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdMacaroons/CMakeLists.txt ===
unset(BUILD_MACAROONS CACHE)

if(NOT ENABLE_MACAROONS)
  return()
endif()

if( FORCE_ENABLED )
  if(NOT ENABLE_HTTP)
    message(SEND_ERROR "Cannot enable XrdMacaroons without HTTP support")
  endif()
  find_package(Macaroons REQUIRED)
else()
  find_package(Macaroons)
endif()

if(NOT APPLE)
  include(FindPkgConfig REQUIRED)
  if(FORCE_ENABLED)
    pkg_check_modules(JSON REQUIRED json-c)
  else()
    pkg_check_modules(JSON json-c)
  endif()
endif()

if(MACAROONS_FOUND AND JSON_FOUND AND BUILD_HTTP)
  set(BUILD_MACAROONS TRUE CACHE INTERNAL "")
else()
  return()
endif()

set(XrdMacaroons XrdMacaroons-${PLUGIN_VERSION})

add_library(${XrdMacaroons} MODULE
  XrdMacaroons.cc
  XrdMacaroonsAuthz.cc       XrdMacaroonsAuthz.hh
  XrdMacaroonsConfigure.cc
  XrdMacaroonsHandler.cc     XrdMacaroonsHandler.hh
)

target_link_libraries(${XrdMacaroons}
  PRIVATE
    XrdHttpUtils
    XrdUtils
    XrdServer
    uuid::uuid
    OpenSSL::Crypto
    ${MACAROONS_LIB}
    ${JSON_LIBRARIES}
    ${CMAKE_DL_LIBS}
)

target_include_directories(${XrdMacaroons}
  PRIVATE
    ${JSON_INCLUDE_DIRS}
    ${MACAROONS_INCLUDES}
)

if(NOT APPLE)
  target_link_options(${XrdMacaroons} PRIVATE
    "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export-lib-symbols")
endif()

install(TARGETS ${XrdMacaroons} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdSut/CMakeLists.txt ===
target_sources(XrdUtils
  PRIVATE
    XrdSutAux.cc         XrdSutAux.hh
    XrdSutBuckList.cc    XrdSutBuckList.hh
    XrdSutBucket.cc      XrdSutBucket.hh
    XrdSutBuffer.cc      XrdSutBuffer.hh
    XrdSutCacheEntry.cc  XrdSutCacheEntry.hh
    XrdSutPFCache.cc     XrdSutPFCache.hh
    XrdSutPFEntry.cc     XrdSutPFEntry.hh
    XrdSutPFile.cc       XrdSutPFile.hh
    XrdSutRndm.cc        XrdSutRndm.hh
    XrdSutTrace.hh
)

=== debian/changelog ===
xrootd (5.8.4-2) unstable; urgency=medium

  * Exclude the XRootD::posix::test test for some architectures

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 18 Jul 2025 17:39:37 +0200

xrootd (5.8.4-1) unstable; urgency=medium

  * Update to version 5.8.4

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 15 Jul 2025 09:23:49 +0200

=== debian/control ===
Source: xrootd
Section: net
Priority: optional
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-installsysusers,
 dpkg-dev (>= 1.22.5),
 dh-python,
 cmake,
 pkgconf,
 libfuse-dev [linux-any kfreebsd-any],
 libkrb5-dev,
 libcurl4-openssl-dev,
 libtinyxml-dev,
 libxml2-dev,
 ncurses-dev,
 libssl-dev,
 libreadline-dev,
 zlib1g-dev,
 libsystemd-dev [linux-any],
 pybuild-plugin-pyproject,
 python3-dev,
 python3-pip,
 python3-setuptools,
 python3-wheel,
 libjson-c-dev,
 libmacaroons-dev,
 uuid-dev,
 voms-dev,
 libscitokens-dev,
 davix-dev,
 librados-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradospp-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradosstriper-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libisal-dev [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 attr,
 curl,
 davix,
 libgtest-dev,
 openssl,
 procps,
 uuid-runtime
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 doxygen,
 graphviz,
 python3-sphinx
Homepage: https://xrootd.web.cern.ch/
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd
Vcs-Git: https://salsa.debian.org/ellert/xrootd.git

Package: xrootd-server
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins (= ${binary:Version}),
 expect,
 logrotate,
 ${perl:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Extended ROOT file server
 The Extended root file server consists of a file server called xrootd
 and a cluster management server called cmsd.
 .
 The xrootd server was developed for the root analysis framework to
 serve root files. However, the server is agnostic to file types and
 provides POSIX-like access to any type of file.
 .
 The cmsd server is the next generation version of the olbd server,
 originally developed to cluster and load balance Objectivity/DB AMS
 database servers. It provides enhanced capability along with lower
 latency and increased throughput.

Package: libxrdapputils2t64
Provides: ${t64:Provides}
Replaces: libxrdapputils2
Breaks: libxrdapputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd applications
 This package contains the xrootd utilities library for applications.

Package: libxrdcrypto2t64
Provides: ${t64:Provides}
Replaces: libxrdcrypto2
Breaks: libxrdcrypto2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Cryptograpic library for xrootd
 This package contains the xrootd cryptograpic library.

Package: libxrdcryptolite2t64
Provides: ${t64:Provides}
Replaces: libxrdcryptolite2
Breaks: libxrdcryptolite2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Light version of cryptograpic library for xrootd
 This package contains the light version of the xrootd cryptograpic library.

Package: libxrdutils3t64
Provides: ${t64:Provides}
Replaces:
 libxrdutils3,
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Breaks:
 libxrdutils3 (<< ${source:Version}),
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd
 This package contains the xrootd utilities library.

Package: libxrdxml3t64
Provides: ${t64:Provides}
Replaces: libxrdxml3
Breaks: libxrdxml3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XML library for xrootd
 This package contains the xrootd XML library.

Package: xrootd-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers and clients
 This package contains plugins used by the xrootd servers and clients.

Package: libxrootd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdapputils2t64 (= ${binary:Version}),
 libxrdcrypto2t64 (= ${binary:Version}),
 libxrdcryptolite2t64 (= ${binary:Version}),
 libxrdutils3t64 (= ${binary:Version}),
 libxrdxml3t64 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd
 This package contains header files and development libraries for xrootd
 development.

Package: libxrdcl3t64
Provides: ${t64:Provides}
Replaces: libxrdcl3
Breaks: libxrdcl3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version})
Description: Client library for xrootd
 This package contains the xrootd client library.

Package: libxrdec1t64
Provides: ${t64:Provides}
Replaces: libxrdec1
Breaks: libxrdec1 (<< ${source:Version})
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Erasure code library for xrootd
 This package contains the xrootd erasure code library.

Package: libxrdffs3t64
Provides: ${t64:Provides}
Replaces: libxrdffs3
Breaks: libxrdffs3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: File protocol library for xrootd
 This package contains the xrootd file protocol library.

Package: libxrdposix3t64
Provides: ${t64:Provides}
Replaces: libxrdposix3
Breaks: libxrdposix3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Posix interface library for xrootd
 This package contains the xrootd Posix interface library.

Package: libxrdssilib2t64
Provides: ${t64:Provides}
Replaces: libxrdssilib2
Breaks: libxrdssilib2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: libxrdssishmap2t64
Provides: ${t64:Provides}
Replaces: libxrdssishmap2
Breaks: libxrdssishmap2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: xrootd-client-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd clients
 This package contains plugins used by xrootd clients.

Package: xrootd-client-http-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP client plugin for XRootD client
 This package contains an XRootD client plugin which allows XRootD to
 interact with HTTP repositories.

Package: libxrootd-client-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdcl3t64 (= ${binary:Version}),
 libxrdffs3t64 (= ${binary:Version}),
 libxrdposix3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd clients
 This package contains header files and development libraries for xrootd
 client development.

Package: libxrdhttputils2t64
Provides: ${t64:Provides}
Replaces: libxrdhttputils2
Breaks: libxrdhttputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP protocol utilities library for xrootd
 This package contains the xrootd HTTP protocol utilities library.

Package: libxrdserver3t64
Provides: ${t64:Provides}
Replaces: libxrdserver3
Breaks: libxrdserver3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins(= ${binary:Version})
Description: Server library for xrootd
 This package contains the xrootd server library.

Package: xrootd-server-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers
 This package contains plugins used by xrootd servers.

Package: libxrootd-server-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdhttputils2t64 (= ${binary:Version}),
 libxrdserver3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd servers
 This package contains header files and development libraries for xrootd
 server development.

Package: libxrootd-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdec1t64 (= ${binary:Version}) [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 libxrdssilib2t64 (= ${binary:Version}),
 libxrdssishmap2t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 libxrootd-server-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Private xrootd headers
 This package contains some private xrootd headers. Backward and forward
 compatibility between versions is not guaranteed for these headers.

Package: xrootd-client
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd command line client tools
 This package contains the command line tools used to communicate with
 xrootd servers.

Package: xrootd-fuse
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins (= ${binary:Version}),
 fuse3 (>= 3.10.1-3) | fuse (<< 3),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd FUSE tool
 This package contains the FUSE (file system in user space) xrootd mount
 tool.

Package: xrootd-voms-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: VOMS attribute extractor plugin for XRootD
 This package contains the xrootd VOMS attribute extractor plugin.

Package: xrootd-scitokens-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: SciTokens authorization support for XRootD
 This ACC (authorization) plugin for the XRootD framework utilizes the
 SciTokens library to validate and extract authorization claims from a
 SciToken passed during a transfer. Configured appropriately, this
 allows the XRootD server admin to delegate authorization decisions for
 a subset of the namespace to an external issuer.

Package: libxrdcephposix0
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Ceph posix library for xrootd
 This package contains an xrootd library used by the ceph plugins.

Package: xrootd-ceph-plugins
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XRootD plugin for interfacing with the Ceph storage platform
 The xrootd-ceph is an OSS layer plugin for the XRootD server for
 interfacing with the Ceph storage platform.

Package: python3-xrootd
Architecture: any
Multi-Arch: foreign
Section: python
Provides:
 ${python3:Provides}
Depends:
 xrootd-plugins (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Disable ceph dependent packages for architectures without ceph
# This list should match the Build-Depends on ceph libraries in debian/control
#
# Ceph requires boost-context and boost-coroutine
# These are only available on these Debian architectures:
#   i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64
#   mips mipsel mips64el powerpc ppc64el riscv64 s390x
#
# Ceph requires Java
# Java is not available on these Debian architectures:
#   hppa hurd-i386 hurd-amd64
#
# Ceph only supports 64 bit architectures
ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 loong64 mips64el ppc64el riscv64 s390x),)
CEPH = ON
else
CEPH = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH_OS),linux kfreebsd),)
FUSE = ON
else
FUSE = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64),)
EC = ON
else
EC = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH),armel armhf hppa loong64 m68k powerpc sh4),)
POSIX_TEST_BROKEN = 1
else
POSIX_TEST_BROKEN = 0
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

BUILD_DOC = $(if $(filter xrootd-doc,$(shell dh_listpackages)),TRUE,FALSE)

%:
	dh $@ --with python3 --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DFORCE_ENABLED:BOOL=ON \
	    -DENABLE_TESTS:BOOL=ON \
	    -DENABLE_FUSE:BOOL=$(FUSE) \
	    -DENABLE_CEPH:BOOL=$(CEPH) \
	    -DENABLE_XRDEC:BOOL=$(EC) \
	    -DPIP_OPTIONS="--no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --verbose"

override_dh_auto_build:
	dh_auto_build
	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	doxygen Doxyfile && \
	sed 's!src=".*/xrootd-logo.png"!src="xrootd-logo.png"!' \
	    -i doxydoc/html/index.html && \
	cp -p docs/images/xrootd-logo.png doxydoc/html )

override_dh_auto_test:
	[ -r tests/XRootD/common.cfg.save ] || \
	    cp -p tests/XRootD/common.cfg tests/XRootD/common.cfg.save

	# Reduce socket path lengths used during tests
	# Tests fail with sockets in the build directory if path is too long
	mktemp -d -p /var/tmp > adminpath
	sed "s!all.adminpath .*!all.adminpath $$(cat adminpath)!" \
	    -i obj-$(DEB_HOST_GNU_TYPE)/tests/cluster/common.cfg \
	       obj-$(DEB_HOST_GNU_TYPE)/tests/badredir/common.cfg \
	       tests/XRootD/common.cfg

	# Use a separate directory for TPC test due to name clash (srv1, srv2)
	mktemp -d -p /var/tmp > adminpath2
	sed "s!all.adminpath .*!all.adminpath $$(cat adminpath2)!" \
	    -i obj-$(DEB_HOST_GNU_TYPE)/tests/TPCTests/common.cfg

	# The XRootD::cluster::test fails the http protocol tests on some hosts
	# https://github.com/xrootd/xrootd/issues/2464

	# The badredir test fails when there is no network - exclude

	# The posix test is broken for 32 bit archs with 64 bit time_t ...
	# https://github.com/xrootd/xrootd/issues/2559
	# ... and for loong64
	# https://github.com/xrootd/xrootd/issues/2560

	touch testfile
	if ( setfattr -n user.testattr -v testvalue testfile ) ; then \
	    if [ $(POSIX_TEST_BROKEN) -eq 1 ] ; then \
		POSIXTEST='XRootD::posix::test|' ; \
	    fi ; \
	    HOSTNAME=localhost \
	    dh_auto_test -- ARGS+="-E '\
$${POSIXTEST}\
XRootD::badredir|\
XRootD::cluster::test'" ; \
	else \
	    echo "Extended file attributes not supported by file system" ; \
	    echo "Don't run tests that require them" ; \
	    HOSTNAME=localhost \
	    dh_auto_test -- ARGS+="-E '\
XrdCl::FileCopyTest|\
XrdCl::FileSystemTest.PlugInTest|\
XrdCl::FileSystemTest.ServerQueryTest|\
XrdCl::FileSystemTest.XAttrTest|\
XrdCl::FileTest.XAttrTest|\
XrdCl::LocalFileHandlerTest.XAttrTest|\
XrdCl::ThreadingTest|\
XrdCl::WorkflowTest.CheckpointTest|\
XrdCl::WorkflowTest.XAttrWorkflowTest|\
XrdEc::XrdEcTests|\
XRootD::badredir|\
XRootD::cluster::test|\
XRootD::http::test|\
XRootD::posix::test|\
XRootD::tpc::test'" ; \
	fi

	rm testfile
	mv tests/XRootD/common.cfg.save tests/XRootD/common.cfg
	rm -rf $$(cat adminpath) $$(cat adminpath2)
	rm adminpath adminpath2

override_dh_auto_clean:
	rm -f testfile
	[ -r tests/XRootD/common.cfg.save ] && \
	    mv tests/XRootD/common.cfg.save tests/XRootD/common.cfg || :
	[ -r adminpath ] && rm -rf $$(cat adminpath) || :
	[ -r adminpath2 ] && rm -rf $$(cat adminpath2) || :
	rm -f adminpath adminpath2
	dh_auto_clean

override_dh_auto_install:
	ln -sf libxrootd-private-dev.install.ec-$(EC) \
	   debian/libxrootd-private-dev.install

	DEB_PYTHON_INSTALL_LAYOUT=deb \
	_PYTHON_HOST_PLATFORM=$(DEB_HOST_ARCH_OS)-$(DEB_HOST_GNU_CPU) \
	dh_auto_install

	rm -f debian/tmp/usr/lib/*/libXrdCephPosix.so

	rm -f debian/tmp/usr/bin/xrdshmap

	rm -f debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/direct_url.json

	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
	PYTHONDONTWRITEBYTECODE=1 \
	make -C bindings/python/docs html && \
	mv bindings/python/docs/build/html bindings/python/docs/build/python )

	# Service unit files
	mkdir -p debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/cmsd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_purged@.service debian/tmp/usr/lib/systemd/system
	mkdir -p debian/tmp/usr/lib/tmpfiles.d
	install -m 644 packaging/rhel/xrootd.tmpfiles debian/tmp/usr/lib/tmpfiles.d/xrootd.conf
	mkdir -p debian/tmp/usr/lib/sysusers.d
	install -m 644 packaging/rhel/xrootd-sysusers.conf debian/tmp/usr/lib/sysusers.d/xrootd.conf

	# Server config
	mkdir -p debian/tmp/etc/xrootd
	install -m 644 -p packaging/common/xrootd-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-clustered.cfg
	install -m 644 -p packaging/common/xrootd-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-standalone.cfg
	install -m 644 -p packaging/common/xrootd-filecache-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-clustered.cfg
	install -m 644 -p packaging/common/xrootd-filecache-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-standalone.cfg
	sed 's!/usr/lib64/!!' packaging/common/xrootd-http.cfg > \
	    debian/tmp/etc/xrootd/xrootd-http.cfg

	# Client config
	mkdir -p debian/tmp/etc/xrootd/client.plugins.d
	install -m 644 -p packaging/common/client.conf \
	    debian/tmp/etc/xrootd/client.conf
	sed 's!/usr/lib/!!' packaging/common/client-plugin.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/client-plugin.conf.example
	sed -e 's!/usr/lib64/!!' -e 's!-5!!' packaging/common/recorder.conf > \
	    debian/tmp/etc/xrootd/client.plugins.d/recorder.conf
	sed 's!/usr/lib64/!!' packaging/common/http.client.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/xrdcl-http-plugin.conf

	chmod 644 debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm
	sed 's!/usr/bin/env perl!/usr/bin/perl!' -i \
	    debian/tmp/usr/share/xrootd/utils/netchk \
	    debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm \
	    debian/tmp/usr/share/xrootd/utils/XrdOlbMonPerf

	sed 's!/usr/bin/env bash!/bin/bash!' -i \
	    debian/tmp/usr/bin/xrootd-config

	mkdir -p debian/tmp/etc/xrootd/config.d

	mkdir -p debian/tmp/var/log/xrootd
	mkdir -p debian/tmp/var/spool/xrootd

	mkdir -p debian/tmp/etc/logrotate.d
	install -m 644 -p packaging/common/xrootd.logrotate \
	    debian/tmp/etc/logrotate.d/xrootd
